import { ApplicationSettings } from '@nativescript/core';
import { Action, Selector, State, StateContext } from '@ngxs/store';
import { catchError, tap } from 'rxjs/operators';
import { APP_ID, wsMaterial } from '~/constants/api.constants';
import { USER_TOKEN } from '~/constants/login-constants';
import { WebApiService } from '~/core/services/web-api.service';
import { WarehouseItemReservationDetail } from '../entities/input/warehouseItemReservationDetail';
import { WarehouseItemReservationUpdateCancel } from '../entities/input/warehouseItemReservationUpdateCancel';
import { WarehouseItemReservationDetailOutput } from '../entities/output/warehouseItemReservationDetailOutput';
import { WarehouseItemReservationUpdateCancelOutput } from '../entities/output/warehouseItemReservationUpdateCancelOutput';
import { CreateDeleteReservation, LoadReservationDetail } from './reservation-borrowed-detail.action';

export interface ReservationBorrowedDetailStateModel {
    loadingWarehouseItemReservationDetail: boolean;
    loadingWarehouseItemReservationUpdateCancel: boolean;
    warehouseItemReservationDetail: WarehouseItemReservationDetailOutput;
}

const initialStateModel: ReservationBorrowedDetailStateModel = {
    loadingWarehouseItemReservationDetail: false,
    loadingWarehouseItemReservationUpdateCancel: false,
    warehouseItemReservationDetail: null
};

@State<ReservationBorrowedDetailStateModel>({
    name: 'reservationBorrowedDetail',
    defaults: initialStateModel
})
export class ReservationBorrowedDetailState {
    @Selector()
    static getReservationDetail(state: ReservationBorrowedDetailStateModel) {
        return state.warehouseItemReservationDetail;
    }

    @Selector()
    static isLoading(state: ReservationBorrowedDetailStateModel) {
        return state.loadingWarehouseItemReservationDetail || state.loadingWarehouseItemReservationUpdateCancel;
    }

    constructor(
        private webApiService: WebApiService
    ) {
    }

    /**
     * Load reservation detail
     *
     * @param {StateContext<ReservationBorrowedDetailStateModel>} ctx
     * @param {LoadReservationDetail} action
     * @returns {Observable<any>}
     */
    @Action(LoadReservationDetail)
    loadReservationDetail(ctx: StateContext<ReservationBorrowedDetailStateModel>, action: LoadReservationDetail) {
        ctx.patchState({
            loadingWarehouseItemReservationDetail: true
        });

        if (action.id) {
            return this.webApiService.call(
                new WarehouseItemReservationDetail(APP_ID, ApplicationSettings.getString(USER_TOKEN), action.id),
                () => new WarehouseItemReservationDetailOutput(),
                wsMaterial
            ).pipe(
                tap((response: WarehouseItemReservationDetailOutput[]) => {
                    if (response.length === 1) {
                        ctx.patchState({
                            loadingWarehouseItemReservationDetail: false,
                            warehouseItemReservationDetail: response[0]
                        });
                    } else {
                        ctx.patchState({
                            loadingWarehouseItemReservationDetail: false,
                            warehouseItemReservationDetail: initialStateModel.warehouseItemReservationDetail
                        });
                        throw new Error('Nepodařilo se nalézt detail rezervace');
                    }
                }),
                catchError(e => {
                    ctx.patchState({
                        loadingWarehouseItemReservationDetail: false,
                        warehouseItemReservationDetail: initialStateModel.warehouseItemReservationDetail
                    });

                    throw e;
                })
            );
        } else {
            ctx.patchState({
                loadingWarehouseItemReservationDetail: false
            });
        }
    }

    /**
     * It create request for reservation delete
     *
     * @param {StateContext<ReservationBorrowedDetailStateModel>} ctx
     * @param {CreateDeleteReservation} action
     * @returns {Observable<any>}
     */
    @Action(CreateDeleteReservation)
    createReservationDelete(ctx: StateContext<ReservationBorrowedDetailStateModel>, action: CreateDeleteReservation) {
        ctx.patchState({
            loadingWarehouseItemReservationUpdateCancel: true
        });

        return this.webApiService.call(
            new WarehouseItemReservationUpdateCancel(APP_ID, ApplicationSettings.getString(USER_TOKEN), action.id),
            () => new WarehouseItemReservationUpdateCancelOutput(),
            wsMaterial
        ).pipe(
            tap((response: WarehouseItemReservationUpdateCancelOutput) => {
                ctx.patchState({
                    loadingWarehouseItemReservationUpdateCancel: false
                });
            }),
            catchError(e => {
                ctx.patchState({
                    loadingWarehouseItemReservationUpdateCancel: false
                });
                throw e;
            })
        );
    }

}
